<template>
    <div class="row">
        <div class="col-6">
            <label for="solicitante" class="form-label">Bloque:</label>
            <auto-complete v-model="data.bloque" :elements="usuarioStore.listadoBloques" placeholder="Bloques"
                :minLength="3" :disabled="false" />
        </div>
        <div class="col-4 mt-3">
            <button  alt="Guardar" title="Guardar" type="button" data-bs-dismiss="modal"  class="btn btn-guardar mt-1 mx-2 fs-3"
             @click="guardar()">
                <i class="fa-solid fa-floppy-disk "></i>
            </button>
            
        </div>
        <!--TABLA-->
        <table class="table  table-striped" v-if="usuarioStore.listadoUsuariosBloquesDiputados.length > 0">
            <thead>
                <tr>
                    <th scope="col">Solicitante</th>
                    <th scope="col"> <input ref="input_todos" id="checkbox_todos" type="checkbox" @click="agregarTodos()" />
                    </th>
                </tr>
            </thead>
            <tbody>
                <tr v-for="diputado in usuarioStore.listadoUsuariosBloquesDiputados" :key="diputado.id_tabla_sol">
                    <td v-text="diputado.apellido + ' ' + diputado.nombres "></td>
                    <td>
                        <input ref="input" id="checkbox_lista" :value="diputado.id_tabla_sol" type="checkbox"
                            @click="agregar(diputado.id_tabla_sol)" />
                    </td>
                </tr>
            </tbody>
        </table>
        <div v-else class="alert alert-secondary" role="alert">
            No hay elementos para mostrar
        </div>
    </div>
</template>

<script setup lang="ts">
//libreries
import { reactive, watch, ref, onMounted } from "vue";
import { useRoute, useRouter } from "vue-router";
import { AutoComplete } from "@hcd-bsas/vue3-components";
import http from "@/http";
import { loading, urlApi } from "@/shared.js";
import Swal from "sweetalert2/dist/sweetalert2.js";
import { AxiosError } from "axios";
//entities
import type Bloque from "@/entities/Bloque";
//store
import { useUsuariosStore } from "@/stores/usuarios";

const emit = defineEmits(["closeModal"]);
const input = ref<HTMLInputElement[] | null>(null);


const input_todos = ref<HTMLInputElement[] | null>(null);

const router = useRouter();
const route = useRoute();

const usuarioStore = useUsuariosStore();

const data = reactive({
    bloque: null as Bloque | null,
    lista: [] as Number[]
});

watch(() => data.bloque?.id_dependen, (newValue: any, oldValue: any) => {
    buscar();
})


async function buscar() {
    loading.show();
    await usuarioStore.updateListadoUsuariosBloquesDiputados({
        id_dependen: data.bloque?.id_dependen,
        id_usuario_perfil: route.params.id
    });
    loading.hide();
}

async function agregar(id_tabla_sol: Number) {
    //cuando destildo 1 tengo que sacar el check todos == false

    var found = data.lista.find(element => element == id_tabla_sol);

    if (found != null) {
        input.value!.forEach((element: HTMLInputElement) => {
            if (element.checked == false) {
                if (element.value == (id_tabla_sol).toString()) {
                    input_todos.value!.checked = false;
                    for (let index = 0; index < data.lista.length; index++) {
                        const element = data.lista[index];
                        if (element == id_tabla_sol) {
                            data.lista.splice(index, 1);
                        }

                    }
                }
            }
        });

    } else {
        var index = data.lista.length - 1;
        data.lista[index + 1] = id_tabla_sol;
    }
}

function agregarTodos() {
    if (data.lista.length > 0) {
        input.value!.forEach((element: HTMLInputElement) => {
            element.checked = false;
            data.lista = [];
            input_todos.value!.checked = false;
        });
    } else {
        input.value!.forEach((element: HTMLInputElement) => {
            element.checked = true;
            data.lista.push(Number(element.value));
        });
    }
}

async function guardar() {
    loading.show();
    try {
        var rta = await http.post(urlApi + "addUsuarioSolicitante", {
            id_usuario_perfil: route.params.id,
            id_tabla_sol: data.lista,
        });
        console.log(rta.data);
        if (rta.data.status == "success") {
            emit("closeModal");
            Swal.hideLoading()
            data.bloque = null;
            await usuarioStore.updateListadoUsuariosSolicitantes({
                id_usuario_perfil: Number(route.params.id),
            });
            Swal.fire({
                icon: "success",
                text: "Se grabo el Solicitante.",
            })
            loading.hide();
        } else {
            Swal.fire({
                icon: "error",
                text: rta.data.message,
            });
            loading.hide();
        }
    } catch (error: any) {
        var mensaje: string = error.message;

        if (error instanceof AxiosError) {
            mensaje = error.response?.data.res.mensaje;
        }
        Swal.fire({
            icon: "error",
            text: mensaje,
        });
    }

    //    loading.show();
    /*     let count: number = 1;
        data.lista.forEach(async (element: Number, index: number) => {
            try {
                var rta = await http.post(urlApi + "addUsuarioSolicitante", {
                    id_usuario_perfil: route.params.id,
                    id_tabla_sol: element,
    
                });
                if (index +1 == data.lista.length) {
                    emit("closeModal");
                    Swal.hideLoading()
                    Swal.fire({
                        icon: "success",
                        text: "Se grabo el Solicitante.",
                    }).then(async () => {
                        //aca actualizar la lista y poner null data.bloque
                        await usuarioStore.updateListadoUsuariosSolicitantes({
                            id_usuario_perfil: route.params.id,
                        });
                        data.bloque = null; */
    /*         router.push({
                name: "inicioUsuarios",
            }); */
    /*  }); */
    //                loading.hide();

    /*  }else{
         let texto = "GUARDANDO "+ count +" DE " + data.lista.length;
         if(count == 1){
             Swal.fire({
                 showConfirmButton:false,
                 text: texto,
                 allowOutsideClick:false,
             });
         } else {
             Swal.update({text:texto});
         }
         Swal.showLoading();
         count +=1;
     } */
    /*             console.log(rta.data);
                if (rta.data.status == "success") {
                     Swal.fire({
                        icon: "success",
                        text: "Se grabo el Solicitante.",
                    }).then(() => {
                        //aca actualizar la lista y poner null data.bloque
                        data.bloque = null;
                        router.push({
                            name: "inicioUsuarios",
                        });
                    }); 
                    loading.hide();
                } else {
                    Swal.fire({
                        icon: "error",
                        text: rta.data.message,
                    });
                    loading.hide();
                }*/
    /*    } catch (error: any) {
           var mensaje: string = error.message;
           console.log("ERROR");
           if (error instanceof AxiosError) {
               mensaje = error.response?.data.res.mensaje;
           }
           Swal.fire({
               icon: "error",
               text: mensaje,
           });
          // loading.hide();
       }
       console.log("GRABO", element);
   }); */

    /*     onMounted(() => {
        data.bloque = null;
    
    });  */

}

onMounted(() => {
    usuarioStore.$patch({ listadoUsuariosBloquesDiputados: [] })

});

//revisar dudas me falta el onMounted limpiar la lista por las dudas
</script>
  
  <!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped></style>